#ifndef __POLYGONIZE_H__
#define __POLYGONIZE_H__

#include <list>


typedef struct Vector3 {
	Vector3() {}
	Vector3(double _x, double _y, double _z) { x = _x; y = _y; z = _z; }
	double x,y,z;
} Vector3;

typedef struct Cube {
	Cube() {}
	Cube(Vector3 _min, Vector3 _max, double (*f)(Vector3))
	{
		double t;
		if (_min.x > _max.x) { t=_min.x; _min.x=_max.x; _max.x=t; }
		if (_min.y > _max.y) { t=_min.y; _min.y=_max.y; _max.y=t; }
		if (_min.z > _max.z) { t=_min.z; _min.z=_max.z; _max.z=t; }
	    min = _min;
		max = _max;

		Vector3 points[8];
		points[0] = Vector3(min.x,min.y,min.z);
		points[1] = Vector3(max.x,min.y,min.z);
		points[2] = Vector3(max.x,min.y,max.z);
		points[3] = Vector3(min.x,min.y,max.z);
		points[4] = Vector3(min.x,max.y,min.z);
		points[5] = Vector3(max.x,max.y,min.z);
		points[6] = Vector3(max.x,max.y,max.z);
		points[7] = Vector3(min.x,max.y,max.z);

		for (int i=0; i<8; i++)
			value[i] = f(points[i]);
 	}

	Vector3 min,max,intersections[12];
	double value[8];
	int vertexFlags;
} Cube;

typedef struct {
	char type;
	unsigned char vertexFlags;
	int edgeFlags;
	bool simple;
} Case;

extern Case cases[256];
int getBit(int flag, int bit);
int makeVertexFlags(int p0, int p1, int p2, int p3, int p4, int p5, int p6, int p7);
int makeEdgeFlags(int p0, int p1, int p2, int p3, int p4, int p5, int p6, int p7, int p8,
				  int p9, int p10, int p11);


void initializePolygonisation();
int classify(Cube *cube);
void calculateIntersections(Cube *cube);
bool polygonize(Cube cube, void(*callback)(Vector3,Vector3,Vector3));

#endif